//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SearchingBoundary0.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
const float Deg2Rad=3.141592653/180;
enum TextPosition { LEFTUP=1,   UP,     RIGHTUP,
                    LEFT,       CENTER, RIGHT,
                    LEFTBOTTOM, BOTTOM, RIGHTBOTTOM,
                    USERDEFINE };

void putText(TCanvas *canvas, int x, int y, char *text,
             TextPosition tp=LEFTUP, int xc=0, int yc=0)
{ int h, w;
  TBrushStyle oldBrushStyle;
  h=canvas->TextHeight(text);
  w=canvas->TextWidth(text);
  switch(tp)
    { case      LEFTUP : x-=w;      y-=h;      break;
      case          UP : x-=(w>>1); y-=h;      break;
      case     RIGHTUP :            y-=h;      break;
      case        LEFT : x-=w;      y-=(h>>1); break;
      case      CENTER : x-=(w>>1); y-=(h>>1); break;
      case       RIGHT :            y-=(h>>1); break;
      case  LEFTBOTTOM : x-=w;                 break;
      case      BOTTOM : x-=(w>>1);            break;
      case RIGHTBOTTOM : break;
      case  USERDEFINE : x-=xc;     y-=yc;
    };
  oldBrushStyle=canvas->Brush->Style;
  canvas->Brush->Style=bsClear;  //
  canvas->TextOut(x, y, text);
  canvas->Brush->Style=oldBrushStyle;

}
// (xc, yc) : the center of rotating text
// (x0, y0) : the relative position to (xc, yc), also assigned by tp.
// It's available for truetype fonts only !!!
void rotateText(TCanvas *canvas, int xc, int yc, char *text,
                TextPosition tp=LEFTUP, int angle=0, int x0=0, int y0=0)
{ int h, w, xn, yn;
  float cosine, sine;
  TLogFont lf;
  TBrushStyle oldBrushStyle;

  GetObject(canvas->Font->Handle, sizeof(TLogFont), &lf);

  h=canvas->TextHeight(text);
  w=canvas->TextWidth(text);
  switch(tp)
    { case      LEFTUP : x0=xc;        y0=yc;        break;
      case          UP : x0=xc-(w>>1); y0=yc;        break;
      case     RIGHTUP : x0=xc-w;      y0=yc;        break;
      case        LEFT : x0=xc;        y0=yc-(h>>1); break;
      case      CENTER : x0=xc-(w>>1); y0=yc-(h>>1); break;
      case       RIGHT : x0=xc-w;      y0=yc-(h>>1); break;
      case  LEFTBOTTOM : x0=xc;        y0=yc-h;      break;
      case      BOTTOM : x0=xc-(w>>1); y0=yc-h;      break;
      case RIGHTBOTTOM : x0=xc-w;      y0=yc-h;      break;
      case  USERDEFINE : x0=xc-x0;     y0=yc-y0;     break; //case of user defines (xc, yc)
    };
  oldBrushStyle=canvas->Brush->Style;
  canvas->Brush->Style=bsClear;  //
  cosine=cos(angle*Deg2Rad);  sine=sin(angle*Deg2Rad);
  xn= xc + (x0-xc)*cosine + (y0-yc)*sine;
  yn= yc - (x0-xc)*sine   + (y0-yc)*cosine;

  lf.lfEscapement=(angle)*10;
  /*
  lf.lfHeight=h;
  lf.lfWidth =0;
  lf.lfWeight = FW_NORMAL;
  lf.lfCharSet = DEFAULT_CHARSET;
  lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
  lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
  lf.lfQuality = DEFAULT_QUALITY;
  lf.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
  */
  canvas->Font->Handle=CreateFontIndirect(&lf);
  canvas->TextOut(xn, yn, text);

  canvas->Brush->Style=oldBrushStyle;
}
//---------------------------------------------------------------------------
int direction[9]= {0,1,2,3,4,5,6,7,8}; // starting from 0 in +x direction, increasing 1 per 45-degrees
                                     // in CCW direction.
int cdX[]={ 1, 1, 0,-1,-1,-1, 0, 1, 0};
int cdY[]={ 0,-1,-1,-1, 0, 1, 1, 1, 0};

int next(int value, int len, int skip=1) // including both direction
{ value += skip;
  if ( skip<0 ) value += len;
  value %= len;
  return (value);
}
const int CW =  1;
const int CCW= -1;
const int Heading = 0;

void __fastcall TForm1::btnShowTextClick(TObject *Sender)
{ Form1->Refresh();
  Form1->Color = RGB(255,255,255);
  Form1->Canvas->Font = FontDialog1->Font;
  Form1->Canvas->Font->Color=RGB(0,0,0);
  //Form1->Canvas->Font->Name = "uC"; //"з";
  //Form1->Canvas->TextOutA(10,10,"mHWAQGS");
  Form1->Canvas->TextOutA(10,10,edShow->Text);
}
//---------------------------------------------------------------------------
int px=110,py=100;

void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  px = X, py = Y;
}
//---------------------------------------------------------------------------
int prevX, prevY;
bool drawing=false;

void __fastcall TForm1::GroupBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  drawing = true;
  prevX = X;
  prevY = Y;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GroupBox1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if ( drawing )
    { int dx = X - prevX;
      int dy = Y - prevY;
      GroupBox1->Left += dx;
      GroupBox1->Top  += dy;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GroupBox1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  drawing = false;        
}
//---------------------------------------------------------------------------
int sftX=10, sftY=120, moveX, moveY;
int index=0;
float scale=3;
unsigned char path[1000];

void __fastcall TForm1::btn90DegreeClick(TObject *Sender)
{
  TColor color = RGB(0,0,0);
  TCanvas * canvas = Form1->Canvas;

  canvas->Pen->Color = RGB(0,0,0);
index = 0;
  while( canvas->Pixels[px][py]!=color )
    { py++; //px++;
      if ( py>Form1->ClientHeight ) return;
    }
moveX = px;  moveY = py;
  int startX, startY;
  startX=px; startY=py;

  int prev=-2, oriX, oriY, heading;
  int dir, previous[8];

  for (dir=0; dir<8; dir+=2)  // to speed up the searching.
     { previous[dir] = next(dir, 8, prev);
     }
  for (dir=0; dir<8; dir+=2)
     { if ( (canvas->Pixels[px+cdX[dir]][py+cdY[dir]]==color) &&
            (canvas->Pixels[px+cdX[previous[dir]]][py+cdY[previous[dir]]]!=color) )
         { heading = dir;
           break;
         }
     }
  if ( dir >= 8 ) return; // isolated point

  oriX = sftX+px*scale;
  oriY = sftY+py*scale;
  canvas->MoveTo(oriX, oriY);
  int toDir;
  do { //for (dir=-2; dir<6; dir+=2)
       for (dir=-3; dir<=4; dir++)
          { toDir = next(heading, 8, dir);
            if ( canvas->Pixels[px+cdX[toDir]][py+cdY[toDir]]==color )
              { px += cdX[toDir];
                py += cdY[toDir];
                //canvas->Pixels[px][py] = RGB(0,255,255);
                heading = toDir;
                break;
              }
          }

       //if ( dir>=6 || px>Form1->ClientWidth  || px<0
       if ( dir>4 || px>Form1->ClientWidth  || px<0
                   || py>Form1->ClientHeight || py<0   )
         break; // isolated point
  path[index++] = toDir;

       canvas->MoveTo(oriX, oriY);
       oriX = sftX+px*scale;
       oriY = sftY+py*scale;
       canvas->LineTo(oriX, oriY);
     }
  while ((px!=startX) || (py!=startY) );
ShowMessage("The length of chain codes : "+ IntToStr(index));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnFontClick(TObject *Sender)
{
  if ( FontDialog1->Execute() )
    { Form1->Canvas->Font = FontDialog1->Font;
      btnFont->Caption = "r ("+Form1->Canvas->Font->Name+")";
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  btnFont->Caption = "r ("+Form1->Canvas->Font->Name+")";        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::edShowKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if ( Key==VK_RETURN )
    {
      btnShowTextClick(edShow);
    }
}
//---------------------------------------------------------------------------
int angle[8]={  0, 45, 90, 135, 180, 225, 270, 315};
int showX=400, showY=300, range=150;
bool stopAnt= true;


void __fastcall TForm1::bbtnAntClick(TObject *Sender)
{
  int x, y, x2, y2, size;

  range = Form1->Canvas->TextWidth("u")+ 10;
  stopAnt = false;
  size = Form1->Canvas->Font->Size;
  Form1->Canvas->Font->Size = 8;
  Form1->Canvas->Font->Color = clRed;

  x=showX+moveX*scale; y=showY+moveY*scale;
  //if ( ! chkAntTraces->Checked )
    { Form1->Canvas->CopyRect( Rect(showX,showY, showX+range*scale,showY+range*scale),
                                Form1->Canvas,
                                Rect(sftX, sftY, sftX+range*scale, sftY+range*scale)
                              );
    }
  //*
  for (int k=0; k<index; k++)
     { if ( !chkAntTraces->Checked )
         { Form1->Canvas->CopyRect(
             Rect(showX,showY, showX+range*scale,showY+range*scale),
             Form1->Canvas,
             Rect(sftX, sftY, sftX+range*scale, sftY+range*scale)
           );
         };
       x2 = x;  y2 = y;
       x += scale*cdX[ path[k] ];
       y += scale*cdY[ path[k] ];

       //if ( k%10!=0 ) continue;
       //Form1->Canvas->LineTo(x,y);
       rotateText(Form1->Canvas, x, y, "¡@",
                  BOTTOM, angle[path[k]]-180 );
       rotateText(Form1->Canvas, x2, y2, "@",
                  BOTTOM, angle[path[k-1]]-180 );
       Application->ProcessMessages();
       Sleep(130);
       if ( stopAnt ) break;
     }
 // */
 Form1->Canvas->Font->Size = size;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bbtnStopClick(TObject *Sender)
{
  stopAnt = true;        
}
//---------------------------------------------------------------------------

